kio Library: ThumbCreator Class Reference (kio Library)

| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# ThumbCreator Class Reference

This is the baseclass for "thumbnail-plugins" in KDE. Baseclass for thumbnail-generating plugins. More...

`#include <thumbcreator.h>`

List of all members.

## Public Types
enum | Flags { None = 0, DrawFrame = 1, BlendIcon = 2 }
## Public Member Functions
virtual bool | create (const QString &path, int width, int height, QImage &img)=0
virtual Flags | flags () const

## Detailed Description

This is the baseclass for "thumbnail-plugins" in KDE. Baseclass for thumbnail-generating plugins.

Using the class KIO::PreviewJob allows you to generate small images (thumbnails) for any kind of file, where a "ThumbCreator" is available. Have a look at kdebase/kioslave/thumbnail/ for existing ThumbCreators.

What you need to do to create and register a ThumbCreator:

- Inherit from this class and reimplement the create() method to generate a thumbnail for the given file-path.
- Provide a factory method in your implementation file to instantiate your plugin, e.g.:

       extern "C"
       {
         ThumbCreator *new_creator()
         {
           return new YourThumbCreator();
         }
       };

Compile your ThumbCreator as a module. The contents of Makefile.am need to look like this:

     INCLUDES = $(all_includes)
     kde_module_LTLIBRARIES = yourthumbcreator.la
     yourthumbcreator_la_SOURCES = yourthumbcreator.cpp
     yourthumbcreator_la_LIBADD = $(LIB_KIO)
     yourthumbcreator_la_LDFLAGS = $(all_libraries) -module $(KDE_PLUGIN)
     kde_services_DATA = yourthumbcreator.desktop

- Create a file yourthumbcreator.desktop with the following contents:

       [Desktop Entry]
       Encoding=UTF-8
       Type=Service
       Name=Name of the type of files your ThumbCreator supports
       ServiceTypes=ThumbCreator
       MimeTypes=application/x-somemimetype
       CacheThumbnail=true
       X-KDE-Library=yourthumbcreator

You can supply a comma-separated list of mimetypes to the MimeTypes entry, naming all mimetypes your ThumbCreator supports. You can also use simple wildcards, like (where you see [slash], put a /)

                  text[slash]* or image[slash]*.

If your plugin is rather inexpensive (e.g. like the text preview ThumbCreator), you can set CacheThumbnail=false to prevent your thumbnails from being cached on disk.

Definition at line 82 of file thumbcreator.h.

## Member Enumeration Documentation

enum ThumbCreator::Flags

| The flags of this plugin. See also: flags() Definition at line 89 of file thumbcreator.h.

## Member Function Documentation

virtual bool ThumbCreator::create | ( | const QString & | path,
|  | int | width,
|  | int | height,
|  | QImage & | img
| ) | `[pure virtual]`

  | Creates a thumbnail Note that the width and height parameters should not be used for scaling. Only plugins that create an image "from scratch", like the TextCreator should directly use the specified size. If the resulting preview is larger than width x height, it will be scaled down. Parameters:
  | path | the (always local) file path to create a preview for
  | width | maximum width for the preview
  | height | maximum height for the preview
  | img | this image will contain the preview on success
Returns: true if preview generation succeeded

virtual Flags ThumbCreator::flags | ( |  | ) | const`[inline, virtual]`

| The flags of this plugin: None nothing special DrawFrame a frame should be painted around the preview BlendIcon the mimetype icon should be blended over the preview. Returns: flags for this plugin Definition at line 117 of file thumbcreator.h.

The documentation for this class was generated from the following file:

- thumbcreator.h

This file is part of the documentation for kio Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:25:29 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003